#include <Keypad.h> // Подключаем библиотеки 
#include <Password.h>

Password password = Password( "1111" );
const byte ROWS = 4; // 4 строки
const byte COLS = 3; // 3 столбца
char keys[ROWS][COLS] = {
  {'1','2','3'},
  {'4','5','6'},
  {'7','8','9'},
  {'*','0','#'}
}; 
//устанавливаем пины столбцов и рядов
byte rowPins[ROWS] = {5, 4, 3, 2};
byte colPins[COLS] = {8, 7, 6}; 
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
#define relay 12
#define ledy 9
#define ledg 10
#define ledr 11



void setup(){
 pinMode(ledy,OUTPUT);  // белый светодиод
 pinMode(ledg,OUTPUT);  // зеленый светодиод
 pinMode(ledr,OUTPUT);  // красный светодиод
 pinMode(relay, OUTPUT);
 digitalWrite(relay, HIGH);   
 Serial.begin(9600);
 keypad.addEventListener(keypadEvent); //добавляем событие
 keypad.setDebounceTime(50);
}

void loop(){
 char key = keypad.getKey();
  if (key){
    Serial.println(key); // Отправляем нажатую клавишу в порт
    digitalWrite(ledy, HIGH);
    delay(100);//Мигаем светодиодом при вводе
  }
  else{digitalWrite(ledy, LOW);
}
}

void keypadEvent(KeypadEvent eKey){
 switch (keypad.getState()){
   case PRESSED:
     Serial.print("Pressed: ");
     Serial.println(eKey);
     switch (eKey){
       case '#': guessPassword(); break;
        default:
              password.append(eKey);
 }
}}

void guessPassword(){
    Serial.print("Guessing password... ");
    if (password.evaluate()){
      digitalWrite(ledg, HIGH);//Включаем зеленый светодиод
    delay(200);
digitalWrite(ledg, LOW);         
digitalWrite(relay,LOW); //активация реле на 0,05 секунд
            delay(10);         
            digitalWrite(relay,HIGH); //отключение реле
   
          Serial.println("VALID PASSWORD "); //
             password.reset(); //сброс переменной пароля после корректного ввода
    }else{
          digitalWrite(relay,HIGH);
            delay(20);
        digitalWrite(ledr, HIGH);
    delay(400);
   
digitalWrite(ledr, LOW);
          Serial.println("INVALID PASSWORD ");
             password.reset(); //сброс переменной пароля после некорректного ввода
    }
} 
